/*###########################################################################
#                                                                           #
#                    Arduino Ethernet Shield 䃂W[                 #
#                                                            				#
###########################################################################*/
#ifndef __AES_H__
#define __AES_H__

#include <avr/io.h>

#define AES_SOCKET_COUNT 4

/* \Pbg[h`				*/
typedef enum {
	MR_TCP			= 0x01 ,			/* TCP							*/
	MR_UDP			= 0x02 ,			/* UDP							*/
	MR_IPRAW		= 0x03 ,			/* IP LAYER RAW SOCK			*/
	MR_MACRAW		= 0x04 , 			/* MAC LAYER RAW SOCK			*/
	MR_PPPOE		= 0x05 ,			/* PPPoE						*/
	MR_ND			= 0x20 ,			/* No Delayed Ack(TCP) flag		*/
	MR_MULTI		= 0x80 				/* support multicating			*/
} SOK_MODE;

/* \PbgXe[^X`(Sn_SR)	*/
typedef enum {
	SOK_CLOSED 		= 0x00 ,			/* closed 						*/
	SOK_INIT		= 0x13 ,			/* init state 					*/
	SOK_LISTEN		= 0x14 ,			/* listen state 				*/
	SOK_SYNSENT	   	= 0x15 ,			/* connection state 			*/
	SOK_SYNRECV		= 0x16 ,			/* connection state 			*/
	SOK_ESTABLISHED	= 0x17 ,			/* success to connect 			*/
	SOK_FIN_WAIT	= 0x18 ,			/* closing state 				*/
	SOK_CLOSING		= 0x1a ,			/* closing state 				*/
	SOK_TIME_WAIT	= 0x1b ,			/* closing state				*/
	SOK_CLOSE_WAIT	= 0x1c ,			/* closing state 				*/
	SOK_LAST_ACK	= 0x1d ,			/* closing state 				*/
	SOK_UDP			= 0x22 ,			/* udp socket 					*/
	SOK_IPRAW		= 0x32 ,			/* ip raw mode socket 			*/
	SOK_MACRAW		= 0x42 ,			/* mac raw mode socket 			*/
	SOK_PPPOE		= 0x5f				/* pppoe socket 				*/ 
} SOK_STATUS;

/* NCAgڑp\Pbg\	*/
typedef struct ASE_SOCKET_t {
	uint8_t mode;
	uint8_t proto;
	uint16_t port;
	uint16_t sport;
	uint8_t ip[4];

	uint16_t txTopAddress;				/* Mobt@擪AhX		*/
	uint16_t txSize;					/* Mobt@TCY			*/
	uint16_t txMask;					/* Mobt@|C^}XN	*/

	uint16_t rxTopAddress;				/* Mobt@擪AhX		*/
	uint16_t rxSize;					/* Mobt@TCY			*/
	uint16_t rxMask;					/* Mobt@|C^}XN	*/

	uint8_t txFlag;						/* Sn_CR_SENDĎtO			*/
	uint16_t txWp;						/* Mobt@AhX			*/

} AES_SOCKET;

/* VXe\̒`				*/
typedef struct AES_SYSTEM_t {
	uint8_t mac[6];						/* MACAhX					*/
	uint8_t ip[4];						/* IPAhX					*/
	uint8_t subnet[4];					/* Tulbg}XN				*/
	uint8_t gateway[4];					/* Q[gEGCAhX			*/
	uint8_t dns[4];						/* DNST[o[AhX			*/
	AES_SOCKET sok[AES_SOCKET_COUNT];	/* e\Pbgp[^			*/
} AES_SYSTEM;

/* ֐vg^Cv錾				*/
void aesInit( AES_SYSTEM *es );
uint8_t aesConnectClient( uint8_t sok ,SOK_MODE mode ,uint8_t *ip ,uint16_t port ,uint8_t proto ,uint8_t wait );
void aesCloseSocket( uint8_t sok );
SOK_STATUS aesGetSocketStatus( uint8_t sok );
uint8_t aesDnsRequest( uint8_t sok ,char *name ,uint8_t *ip );
void aesWriteTxBuffer( uint8_t sok ,void *msg ,uint16_t len );
void aesWriteTxBuffer_P( uint8_t sok ,prog_void *data ,uint16_t len );
void aesStrWriteTxBuffer( uint8_t sok ,char *str );
void aesStrWriteTxBuffer_P( uint8_t sok ,prog_char *str );
uint16_t aesGetTxFree( uint8_t sok );
void aesSendProcessTx( uint8_t sok );
uint16_t aesReadRdBuffer( uint8_t sok ,void *data ,uint16_t len );
uint16_t aesStrReadRdBuffer( uint8_t sok ,char *str ,char ch ,uint16_t len );
uint8_t aesWaitReceive( uint8_t sok ,uint16_t n );
uint16_t aesGetRdCount( uint8_t sok );

#endif
