/*###########################################################################
#                                                                           #
#          FuArduino Ethernet ShieldvSHOUTcastM           #
#                                                                           #
# gpSDJ[h̃t@CVXe͔j󂳂ׁAgpOɃf[^        #
#   obNAbv邱ƁBPCŎgpƂ́AtH[}bg邱          #
#                                                                           #
###########################################################################*/
#define __MAIN_C__

#define START_SECTOR ( 1024L )		/* obt@OJnZN^ԍ			*/

#include <stdio.h> 
#include <string.h> 

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <util/crc16.h>

#include "soft_usart.h"
#include "aes.h"
#include "vs10xx.h"
#include "diskio.h"

/*										*/
/* lbg[N{					*/
/*										*/
AES_SYSTEM es = {	{ 0xde, 0xad, 0xbe, 0xef, 0xfe, 0xed } ,	/* MACAhX			*/
					{ 192, 168,   0, 123 } ,					/* IPAhX			*/
					{ 255, 255, 255,   0 } ,					/* Tulbg			*/
					{ 192, 168,   0,   1 } ,					/* Q[gEGC			*/
					{ 192, 168,   0,   1 }						/* DNST[o[			*/
};

/* T[o[							*/
static char stationURL[128];									/* T[o[URL			*/
static char stationName[128];									/* T[o[			*/

/* }N`							*/
#define TIMER_MS_TO_COUNT(tim) ( (uint16_t)( ( ( F_CPU / 1024L ) * (uint32_t)tim ) / 1000L ) )
#define WAIT_MS(tim) { uint16_t cnt = (uint16_t)(tim); while ( cnt-- ) { _delay_ms( 1 ); } }

/* [J֐vg^Cv錾			*/
static void hardwareInit( void );
static void clearBuffer( void );
static uint16_t strToUint16( char *p );
static uint32_t strToUint32( char *p );
static void dispEthernetInfo( void );
static void dispShoutcastInfo( void );
static void dispVS1053bInfo( void );
static uint8_t connectStreamingSserver( uint8_t sok ,char *url );
static uint8_t playShoutcast( char *url ,uint8_t vol );
static void pollUsart( void );
static void clearUsart( void );
static uint8_t loadSector( uint32_t sec );
static uint8_t saveSector( uint32_t sec );
static uint16_t getCRC16( void *p ,uint16_t len );

/* [Jϐ							*/
static volatile uint32_t timer10 = 0L;	/* 10msecPʂŃJEgAbv		*/
static volatile uint16_t timeOut = 0;	/* 10msecPʂŃJEg_E		*/
static volatile uint8_t tick10ms = 0;	/* 10mseco߂ŗtO			*/
static volatile uint8_t tickSec = 0;	/* 1bo߂ŗtO				*/

static volatile char rdBuf[128];		/* USART Mobt@				*/
static volatile uint8_t rdLen = 0;		/* USART Mobt@f[^		*/
static volatile uint8_t crRecv = 0;		/* USART [CR]MɗtO		*/

static uint8_t dispSts;					/* obt@񃂃j^[NtO	*/
static uint8_t buf[512];				/* ėpobt@						*/
static uint8_t rbuf[512];				/* Đf[^obt@				*/
static uint32_t secLast = 0L;			/* SDJ[h̍ŏIZN^ԍ			*/
static uint32_t secWp = 0L;				/* ZN^Cg|C^				*/
static uint32_t secRp = 0L;				/* ZN^[h|C^				*/
static uint8_t secDcnt = 0;				/* obt@OĂZN^	*/

static volatile uint8_t sysMode;		/* VXe						*/
#define MODE_STOP      ( 0x00 )			/* Đ~						*/
#define MODE_CONNECT   ( 0x01 )			/* ڑ						*/
#define MODE_BUFFERING ( 0x82 )			/* obt@O					*/
#define MODE_PLAYING   ( 0x83 )			/* Đ							*/
#define MODE_PAUSE     ( 0x04 )			/* ꎞ~						*/

/*****************************************************************************
*				PCINT0(\tgusart Mobt@)荞
*****************************************************************************/
ISR( PCINT0_vect )
{
	uint8_t c;
	if ( !( PINB & _BV(1) ) ) {					/* ̎̂ݏs	*/
		c = sfUsartGetc();
		if ( !crRecv ) {
			if ( c == 0x0d ) {					/* cr						*/
				rdBuf[rdLen] = '\0';
				rdLen = 0;
				crRecv = 1;
			} else if ( c == 0x08 ) {			/* back space				*/
				if ( rdLen ) {
					rdLen--;
				}
			} if ( ( rdLen < ( sizeof(rdBuf) - 1 ) ) && ( c >= 0x20 ) && ( c <= 0x7e ) ) {
				rdBuf[rdLen++] = c;
			}
		}
	}
}

/*****************************************************************************
*						timer0(8bit)ɂ10msec̊荞
*****************************************************************************/
ISR( TIMER0_COMPA_vect )
{
	static uint8_t sec = 0;

	timer10++;
	tick10ms = 1;

	if ( ++sec >= 100 ) {
		sec = 0;
		tickSec = 1;
	}

	if ( timeOut ) {
		timeOut--;
	}

	OCR0A += TIMER_MS_TO_COUNT( 10 );
}

/*****************************************************************************
*								n[hEGA
*	Fvoid
*	ߒlFvoid
*****************************************************************************/
static void hardwareInit( void )
{
	/*  PortB +--------7: Pullup : XTAL                                         */
	/*        |+-------6: Pullup : XTAL                                         */
	/*        ||+------5: Out(L) : Ethernet Shield SCK                          */
	/*        |||+-----4: ZHI    : Ethernet Shield MISO                         */
	/*        ||||+----3: Out(L) : Ethernet Shield MOSI                         */
	/*        |||||+---2: Out(H) : Ethernet Shield CS	 						*/
	/*        ||||||+--1: Pullup : Soft Usart RX                                */
	/*        |||||||+-0: Out(H) : Soft Usart TX                                */
	DDRB  = 0b00101101;
	PORTB = 0b00000111;

	/*  PortC +--------7: OUT(L) : ---                                          */
	/*        |+-------6: OUT(L) : ---                                          */
	/*        ||+------5: Out(L) : Ethernet Shield RESET						*/
	/*        |||+-----4: Out(L) : gp	                                    */
	/*        ||||+----3: OUT(L) : LED(R)                                       */
	/*        |||||+---2: OUT(L) : LED(G)                                       */
	/*        ||||||+--1: Pullup : SW2                                          */
	/*        |||||||+-0: Pullup : SW1                                          */
	DDRC  = 0b11111100;
	PORTC = 0b00000011;


	/* 	PortD +--------7: Out(L) : VS1053b Reset                                */
	/*        |+-------6: Out(H) : VS1053b XDS                                  */
	/*        ||+------5: Out(H) : VS1053b XCS                                  */
	/*        |||+-----4: Out(L) : VS1053b SCK                                  */
	/*        ||||+----3: Pullup : VS1053b DREQ                                 */
	/*        |||||+---2: Out(H) : SD-card CS                                   */
	/*        ||||||+--1: Out(L) : VS1053b MOSI                                 */
	/*        |||||||+-0: ZHI    : VS1053b MISO                                 */
	DDRD  = 0b11110110;
	PORTD = 0b01101100;

	/* AiORp[^					*/
	ACSR = _BV(ACD);

	/* EIb`hbN						*/
	MCUSR &= ~_BV(WDRF);
	WDTCSR |= ( _BV(WDCE) | _BV(WDE) );
	WDTCSR = 0x00;

	/* ^C}[0(8bit) 10msec̊荞ݐݒ	*/
	TCCR0B =  0x05;										/* VXeNbN1024			*/
	TCNT0  =  0;
	OCR0A  =  TIMER_MS_TO_COUNT( 10 );					/* F_CPU = 16MHzŌvZ					*/
	TIMSK0 |= _BV(OCIE0A);

	/* \tgUsart RD݋					*/
	PCICR = 0x01;										/* RD = PB1								*/
	PCMSK0 = 0x02;

	/* O[oC^vgL				*/
	sei();

	/* C[TlbgV[h				*/
	es.sok[0].rxSize = 8192;					/* \Pbg0̎Mobt@TCY				*/
	es.sok[0].txSize = 8192;					/* \Pbg0̑Mobt@TCY				*/
	aesInit( &es );

	/* \tgUSART						*/
	sfUsartInit();

	/* SDJ[h							*/
	for ( uint8_t i = 25 ;i ;i-- ) {
		sfUsartPuts_P( PSTR("") );
	}
	sfUsartPuts_P( PSTR("------------ Arduino Ethernet Shield Test ------------") );
	sfUsartPuts_P( PSTR("SD card initialize ....") );
	while ( 1 ) {
		WAIT_MS( 1000 );
		if ( disk_initialize( 0 ) != RES_OK ) {
			continue;
		}

		if ( disk_ioctl( 0 ,GET_SECTOR_COUNT ,&secLast ) != RES_OK ) {
			continue;
		}

		break;
	}

	/* vs1053b							*/
	vsInit();

	/* obt@Oϐ					*/
	secLast--;
	secWp = START_SECTOR;
	clearBuffer();

	sprintf_P( (char *)buf ,PSTR("The SD card has %lu sectors.") ,secLast + 1L );
	sfUsartPuts( (char *)buf );
	sfUsartPuts_P( PSTR("") );
}

/*****************************************************************************
*							Oobt@NA
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void clearBuffer( void )
{
	if ( ( secWp > secWp ) || ( secWp < START_SECTOR ) ) {
		secWp = START_SECTOR;
	}
	secDcnt = 0;
	secRp = secWp;
}

/*****************************************************************************
*							𐔒lɕϊ
* Fchar *p  
* ߒlFuint16_t l
*****************************************************************************/
static uint16_t strToUint16( char *p )
{
	uint16_t ret = 0;
	while ( ( *p ) && ( *p >= '0' ) && ( *p <= '9' ) ) {
		ret *= 10;
		ret += (uint16_t)( *p - '0' );
		p++;
	}
	return ( ret );
}

static uint32_t strToUint32( char *p )
{
	uint32_t ret = 0;
	while ( ( *p ) && ( *p >= '0' ) && ( *p <= '9' ) ) {
		ret *= 10L;
		ret += (uint32_t)( *p - '0' );
		p++;
	}
	return ( ret );
}

/*****************************************************************************
*						C[TlbgR\[ɏo
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void dispEthernetInfo( void )
{
	char *txt = (char *)buf;

	sfUsartPuts_P( PSTR("<< ethernet info >>") );
	sprintf_P( txt ,PSTR("mac address : %02x:%02x:%02x:%02x:%02x:%02x") ,es.mac[0] ,es.mac[1] ,es.mac[2] ,es.mac[3] ,es.mac[4] ,es.mac[5] );
	sfUsartPuts( txt );

	sprintf_P( txt ,PSTR("ip address  : %3d.%3d.%3d.%3d") ,es.ip[0] ,es.ip[1] ,es.ip[2] ,es.ip[3] );
	sfUsartPuts( txt );

	sprintf_P( txt ,PSTR("subnet      : %3d.%3d.%3d.%3d") ,es.subnet[0] ,es.subnet[1] ,es.subnet[2] ,es.subnet[3] );
	sfUsartPuts( txt );

	sprintf_P( txt ,PSTR("gateway     : %3d.%3d.%3d.%3d") ,es.gateway[0] ,es.gateway[1] ,es.gateway[2] ,es.gateway[3] );
	sfUsartPuts( txt );

	sprintf_P( txt ,PSTR("dns         : %3d.%3d.%3d.%3d") ,es.dns[0] ,es.dns[1] ,es.dns[2] ,es.dns[3] );
	sfUsartPuts( txt );
}

/*****************************************************************************
*			ڑĂshoutcaseT[o[R\[ɏo
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void dispShoutcastInfo( void )
{
	char *txt = (char *)buf;

	sfUsartPuts_P( PSTR("<< shoutcast server info >>") );

	sprintf_P( txt ,PSTR("url         : %s") ,stationURL );
	sfUsartPuts( txt );

	sprintf_P( txt ,PSTR("name        : %s") ,stationName );
	sfUsartPuts( txt );

	sprintf_P( txt ,PSTR("ip address  : %3d.%3d.%3d.%3d") ,es.sok[0].ip[0] ,es.sok[0].ip[1],es.sok[0].ip[2],es.sok[0].ip[3] );
	sfUsartPuts( txt );

	sprintf_P( txt ,PSTR("port        : %d") ,es.sok[0].port );
	sfUsartPuts( txt );
}

/*****************************************************************************
*							vs1053bR\[ɏo
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void dispVS1053bInfo( void )
{
	/* MP3 rbg[ge[u`	*/
	static const prog_int16_t tbl1[] = {  0 , 32 , 40 , 48 , 56 , 64 , 80 , 96 ,112 ,128 ,160 ,192 ,224 ,256 ,320 ,  0 };
	static const prog_int16_t tbl2[] = {  0 ,  8 , 16 , 24 , 32 , 40 , 48 , 56 , 64 , 80 , 96 ,112 ,128 ,144 ,160 ,  0 };

	char *txt = (char *)buf;
	uint16_t h0;
	uint16_t h1;
	uint16_t au;
	uint16_t bitRate;

	sfUsartPuts_P( PSTR("<< vs1053b info >>") );

	h0 = vsRegRead( SCI_HDAT0 );
	h1 = vsRegRead( SCI_HDAT1 );
	bitRate = (uint16_t)( ( (uint32_t)h0 * 8L ) / 1000L );

	switch ( h1 ) {
		case 0x7665:							/* WAVE									*/
			sfUsartPuts_P( PSTR("Data type     : WAVE" ) );
			break;

		case 0x4154:							/* AAC									*/
		case 0x4144:
		case 0x4d34:
			sfUsartPuts_P( PSTR("Data type     : AAC" ) );
			break;

		case 0x574d:							/* WMA									*/
			sfUsartPuts_P( PSTR("Data type     : WMA" ) );
			break;

		case 0x4d54:							/* MIDI									*/
			sfUsartPuts_P( PSTR("Data type     : MIDI" ) );
			break;

		case 0x4f67:							/* OGG									*/
			sfUsartPuts_P( PSTR("Data type     : OGG" ) );
			break;

		default:
			sfUsartPuts_P( PSTR("Data type     : MP3" ) );
			if ( ( ( h1 & 0x0018 ) >>  3 ) == 3 ) {
				bitRate = pgm_read_word( &tbl1[ ( ( h0 & 0xf000 ) >> 12 ) ] );
			} else {
				bitRate = pgm_read_word( &tbl2[ ( ( h0 & 0xf000 ) >> 12 ) ] );
			}
			break;
	}

	au = vsRegRead( SCI_AUDATA ) & 0xfffe;
	sprintf_P( txt ,PSTR("Sampling rate : %u.%uKHz") ,au / 1000 ,( au / 100 ) % 10 );
	sfUsartPuts( txt );

	sprintf_P( txt ,PSTR("Bit rate      : %uKbps") ,bitRate );
	sfUsartPuts( txt );
}

/*****************************************************************************
*					w̃Xg[~OT[o[֐ڑ
* Fuint8_t sok \Pbgԍ
*       char *url   ڑurl
* ߒlFuint8_t     0:OK !0:NG
****************************************************************************/
static uint8_t connectStreamingSserver( uint8_t sok ,char *url )
{
	uint8_t ret;
	uint8_t ip[4];
	uint16_t port = 8000;
	uint16_t n;
	char *p;
	char *txt = (char *)buf;

	/* DNST[o[₢킹		*/
	sprintf_P( txt ,PSTR("url : %s") ,url );
	sfUsartPuts( txt );

	ret = aesDnsRequest( 0 ,url ,ip );
	if ( ret != 0 ) {
		sfUsartPuts_P( PSTR("DNS error") );
		return ( 1 );
	}

	/* url http:// XLbv		*/
	n = strlen( url );
	while ( n > 3 ) {
		if ( ( url[0] == ':' ) && ( url[1] == '/' ) && ( url[2] == '/' ) ) {
			url += 3;
			break;
		}
		url++;
		n--;
	}

	/* |[gԍ擾				*/
	p = url;
	while ( *p ) {
		if ( ( *p ) == ':' ) {
			port = strToUint16( p + 1 );
			break;
		}
		p++;
	}

	/* fBNg擾			*/
	p = url;
	while ( *p ) {
		if ( *p == '/' ) {
			p++;
			break;
		}
		p++;
	}

	sprintf_P( txt ,PSTR("ip address : %d.%d.%d.%d") ,ip[0] ,ip[1] ,ip[2] ,ip[3] );
	sfUsartPuts( txt );

	sprintf_P( txt ,PSTR("port : %d") ,port );
	sfUsartPuts( txt );

	sfUsartPuts_P( PSTR("") );

	/* T[o[֐ڑ				*/
	ret = aesConnectClient( sok ,MR_TCP | MR_ND ,ip ,port ,6 ,1 );
	if ( ret != 0 ) {
		sfUsartPuts_P( PSTR("Streaming server connect error") );
		return ( 2 );
	}

	/* f[^vbZ[WM		*/
	strcpy_P( txt ,PSTR("GET /") );
	strcat( txt ,p );
	strcat_P( txt ,PSTR(" HTTP/1.0\r\n") );
	aesStrWriteTxBuffer( sok ,txt );
	sfUsartPuts( txt );

	sprintf_P( txt ,PSTR("Host: %d.%d.%d.%d\r\n") ,ip[0] ,ip[1] ,ip[2] ,ip[3] );
	aesStrWriteTxBuffer( sok ,txt );
	sfUsartPuts( txt );

	strcpy_P( txt ,PSTR("User-Agent: WinampMPEG/2.9\r\n") );
	aesStrWriteTxBuffer( sok ,txt );
	sfUsartPuts( txt );

	strcpy_P( txt ,PSTR("Accept: */*\r\n") );
	aesStrWriteTxBuffer( sok ,txt );
	sfUsartPuts( txt );

	strcpy_P( txt ,PSTR("\r\n") );
	aesStrWriteTxBuffer( sok ,txt );
	sfUsartPuts( txt );

	aesSendProcessTx( sok );

	/* T[o[̉҂		*/
	ret = 100;
	stationName[0] = '\0';
	while ( 1 ) {

		n = aesStrReadRdBuffer( sok ,txt ,'\n' ,256 );
		if ( n == 0 ) {
			aesCloseSocket( sok );
			sfUsartPuts_P( PSTR("Streaming sserver timeout") );
			return ( 3 );
		}

		if ( ( n == 2 ) && ( txt[0] == '\r' ) && ( txt[1] == '\n' ) ) {
			break;
		}

		/* ICY 200 OK `FbN		*/
		if ( n >= 10 ) {
			if ( strncasecmp_P( txt ,PSTR("icy 200 ok") ,10 ) == 0 ) {
				ret = 0;
			}
		}

		/* icy-name: 擾			*/
		if ( n > 9 ) {
			if ( strncasecmp_P( txt ,PSTR("icy-name:") ,9 ) == 0 ) {
				n -= 9;
				if ( n > ( sizeof(stationName) - 1 ) ) {
					n = sizeof(stationName) - 1;
				}
				memset( stationName ,0x00 ,sizeof(stationName) );
				memcpy( stationName ,&txt[9] ,n );
			}
		}

		sfUsartPuts( txt );
	}

	if ( !ret ) {
		sfUsartPuts_P( PSTR("OK") );

		strcpy_P( (char *)buf ,PSTR("No.FF ") );
		strcpy( (char *)&buf[6] ,stationURL );
		strcpy( (char *)&buf[256] ,stationName );
		saveSector( 100L );
	}

	return ( ret );
}

/*****************************************************************************
*						Xg[~OĐC
* Fchar *url   shoutcastT[o[url
*		uint8_t vol Đ(0`180)
* ߒlFuint8_t     IR[h
*****************************************************************************/
static uint8_t playShoutcast( char *url ,uint8_t vol )
{
	uint8_t sts;
	uint8_t fvol;
	uint16_t dlen;				/* Đobt@f[^					*/
	uint8_t *p;					/* Đobt@̍Đʒuւ̃|C^		*/

	/* ĐC[v									*/
	sysMode = MODE_CONNECT;
	while ( sysMode != MODE_STOP ) {

		/* usartM								*/
		pollUsart();

		/* T[o[ڑ									*/
		if ( sysMode == MODE_CONNECT ) {
			vsResetPlayMode();
			vsSetVolume( 0 );
			clearUsart();
			clearBuffer();
			fvol = 0;
			dlen = 0;
			dispSts = 0;
			sts = connectStreamingSserver( 0 ,url );
			if ( sts == 0 ) {							/* ڑ				*/
				sysMode = MODE_BUFFERING;
				sfUsartPuts_P( PSTR("The buffering began.") );
			} else {
				sysMode = MODE_PAUSE;
			}
		}

		if ( sysMode & 0x80 ) {

			/* Mf[^obt@O					*/
			if ( ( aesGetRdCount( 0 ) >= 512 ) && ( secDcnt != 255 ) ) {
				aesReadRdBuffer( 0 ,(void *)buf ,512 );
				if ( disk_write( 0 ,buf ,secWp ,1 ) != RES_OK ) {
					aesCloseSocket( 0 );
					sfUsartPuts_P( PSTR("SD card write error") );
					return ( 1 );
				}
				secWp++;
				if ( secWp > secLast ) {
					secWp = START_SECTOR;
				}
				secDcnt++;
				timeOut = 500;

				/* Đ[hɈڍs						*/
				if ( ( sysMode == MODE_BUFFERING ) && ( secDcnt > 64 ) ) {
					sfUsartPuts_P( PSTR("The play began.") );
					sysMode = MODE_PLAYING;
					timer10 = 0;
				}
			}

			if ( sysMode == MODE_PLAYING  ) {

				/* obt@f[^Ǎ						*/
				if ( secDcnt && !dlen ) {
					if ( disk_read( 0 ,rbuf ,secRp ,1 ) != RES_OK ) {
						aesCloseSocket( 0 );
						sfUsartPuts_P( PSTR("SD card read error") );
						return ( 2 );
					}
					secRp++;
					if ( secRp > secLast ) {
						secRp = START_SECTOR;
					}
					secDcnt--;
					p = (uint8_t *)rbuf;
					dlen = 512;
					timeOut = 500;
				}

				/* ʃtF[hC						*/
				if ( ( fvol < vol ) && tick10ms ) {
					tick10ms = 0;
					fvol += 2;
					vsSetVolume( fvol );
				}

				/* f[^Đ							*/
				if ( dlen && vsGetDREQ() ) {
					vsXDCS( 1 );
					do {
						vsWriteByte( *p++ );
					} while ( --dlen && vsGetDREQ() );
					vsXDCS( 0 );
				}
			}

			/* ^CAEg̏						*/
			if ( timeOut == 0 ) {
				sysMode = MODE_CONNECT;
				sfUsartPuts_P( PSTR("It became a time-out while receiving data from the server.") );
			}
		}
	}

	aesCloseSocket( 0 );
	return ( 0 );
}

/*****************************************************************************
*							usartM
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void pollUsart( void )
{
	uint16_t m;
	uint16_t s;
	uint8_t sts = 1;
	char *cmd = (char *)rdBuf;
	char *txt = (char *)buf;

	/* obt@Xe[^X\		*/
	if ( dispSts && tickSec ) {
		tickSec = 0;
		m = (uint16_t)( ( timer10 / 6000L ) % 60L );
		s = (uint16_t)( ( timer10 / 100L ) % 60L );
		txt = (char *)buf;
		sprintf_P( txt ,PSTR("w[%8lu] r[%8lu] d[%3u]   Time %u:%02u") ,secWp ,secRp ,secDcnt ,m ,s );
		while ( *txt ) {
			sfUsartPutc( *txt++ );
		}
		sfUsartPutc( '\r' );
	}

	if ( !crRecv ) {					/* Mf[^					*/
		return;
	}
	crRecv = 0;

	sfUsartPuts_P( PSTR("") );
	if ( dispSts ) {
		dispSts = 0;
		sfUsartPuts_P( PSTR("end of monitor") );
		return;
	}

	/* ZbgR}h	uresetv		*/
	if ( strcasecmp_P( cmd ,PSTR("reset") ) == 0 ) {
		sysMode = MODE_STOP;
		return;

	/* ԃj^[R}h	umonitorv	*/
	} else if ( strcasecmp_P( cmd ,PSTR("monitor") ) == 0 ) {
		if ( dispSts == 0 ) {
			dispSts = 1;
			sts = 0;
		}

	/* ꎞ~R}h	upausev		*/
	} else if ( strcasecmp_P( cmd ,PSTR("pause") ) == 0 ) {
		if ( sysMode == MODE_PLAYING ) {
			sysMode = MODE_PAUSE;
			sts = 0;
		}

	/* ĐJnR}h	uplayv		*/
	} else if ( strcasecmp_P( cmd ,PSTR("play") ) == 0 ) {
		if ( sysMode == MODE_PAUSE ) {
			sysMode = MODE_PLAYING;
			timeOut = 500;
			sts = 0;
		}

	/* VXe擾uinfov			*/
	} else if ( strcasecmp_P( cmd ,PSTR("info") ) == 0 ) {
		dispEthernetInfo();
		sfUsartPuts_P( PSTR("") );
		dispShoutcastInfo();
		sfUsartPuts_P( PSTR("") );
		dispVS1053bInfo();

		sfUsartPuts_P( PSTR("") );
		if ( sysMode == MODE_STOP ) {
			sfUsartPuts_P( PSTR("mode is STOP") );
		} else if ( sysMode == MODE_CONNECT ) {
			sfUsartPuts_P( PSTR("mode is CONNECT") );
		} else if ( sysMode == MODE_BUFFERING ) {
			sfUsartPuts_P( PSTR("mode is BUFFERING") );
		} else if ( sysMode == MODE_PLAYING ) {
			sfUsartPuts_P( PSTR("mode is PLAYING") );
		} else if ( sysMode == MODE_PAUSE ) {
			sfUsartPuts_P( PSTR("mode is PAUSE") );
		} else {
			sfUsartPuts_P( PSTR("mode is error") );
		}
		sts = 0;

	/* urlύXuhttp://v				*/
	} else if ( strncasecmp_P( cmd ,PSTR("http://") ,7 ) == 0 ) {
		memset( stationURL ,0x00 ,sizeof(stationURL) );
		strncpy( stationURL ,cmd ,sizeof(stationURL) - 1 );
		sysMode = MODE_CONNECT;
		sts = 0;
	
	/* wCfbNX̃T[o[ɐڑuch nv	*/
	} else if ( strncasecmp_P( cmd ,PSTR("ch ") ,3 ) == 0 ) {
		uint16_t idx = strToUint16( &cmd[3] );
		if ( ( idx >= 1 ) && ( idx <= 99 ) ) {
			if ( ( loadSector( (uint32_t)idx ) == 0 ) && buf[0] ) {
				strcpy( stationURL ,(char *)&buf[6] );
				strcpy( stationName ,(char *)&buf[256] );
				sysMode = MODE_CONNECT;
				sts = 0;
			}
		}

	/* ZN^_vudumpv				*/
	} else if ( strncasecmp_P( cmd ,PSTR("dump ") ,5 ) == 0 ) {
		uint32_t sec = strToUint32( &cmd[5] );
		sprintf_P( txt ,PSTR("sector %lu") ,sec );
		sfUsartPuts( txt );

		if ( disk_read( 0 ,buf ,sec ,1 ) != RES_OK ) {
			sfUsartPuts_P( PSTR("SD card read error") );
		} else {
			sfUsartDump( buf ,512 );
		}
		sts = 0;

	/* o^T[o[S폜ueraseallv	*/
	} else if ( strcasecmp_P( cmd ,PSTR("eraseall") ) == 0 ) {
		memset( buf ,0x00 ,512 );
		for ( uint8_t i = 1 ;i < 99 ;i++ ) {
			saveSector( (uint32_t)i );
		}
		sts = 0;

	/* wCfbNX폜	udel nv	*/
	} else if ( strncasecmp_P( cmd ,PSTR("del ") ,4 ) == 0 ) {
		uint16_t idx = strToUint16( &cmd[4] );
		if ( ( loadSector( (uint32_t)idx ) == 0 ) && buf[0] ) {
			memset( buf ,0x00 ,512 );
			saveSector( (uint32_t)idx );
			sts = 0;
		}

	/* o^T[o[ꗗulistv			*/
	} else if ( strcasecmp_P( cmd ,PSTR("list") ) == 0 ) {
		for ( uint8_t i = 1 ;i < 99 ;i++ ) {
			if ( ( loadSector( (uint32_t)i ) == 0 ) && buf[0] ) {
				sfUsartPuts( (char *)&buf[0] );
				sfUsartPutc( ' ' );
				sfUsartPutc( ' ' );
				sfUsartPutc( ' ' );
				sfUsartPutc( ' ' );
				sfUsartPutc( ' ' );
				sfUsartPutc( ' ' );
				sfUsartPuts( (char *)&buf[256] );
				sfUsartPuts_P( PSTR("") );
			}
		}
		sts = 0;

	/* ݂̃T[o[ǉo^uaddv	*/
	} else if ( ( strcasecmp_P( cmd ,PSTR("add") ) == 0 ) && ( sysMode & 0x80 ) ) {

		/* URL						*/
		uint8_t n = 0;
		for ( uint8_t i = 1 ;i < 99 ;i++ ) {
			if ( ( loadSector( (uint32_t)i ) == 0 ) && buf[0] ) {
				if ( strcasecmp( stationURL ,(char *)&buf[6] ) == 0 ) {
					n = i;
					sfUsartPuts_P( PSTR("Specified URL has already been registered.") );
					break;
				}
			}
		}

		if ( n == 0 ) {

			/* 󂫃CfbNX		*/
			n = 0;
			for ( uint16_t i = 1 ;i < 99 ;i++ ) {
				if ( ( loadSector( (uint32_t)i ) == 0 ) && !buf[0] ) {
					n = i;
					break;
				}
			}

			if ( n ) {
				/* ۑ					*/
				sprintf_P( (char *)buf ,PSTR("No.%02d ") ,n );
				strcpy( (char *)&buf[6] ,stationURL );
				strcpy( (char *)&buf[256] ,stationName );
				if ( saveSector( (uint32_t)n ) == 0 ) {
					sprintf_P( txt ,PSTR("add index %d") ,n );
					sfUsartPuts( txt );
					sts = 0;
				} else {
					sfUsartPuts_P( PSTR("SD card write error") );
				}
			} else {
				sfUsartPuts_P( PSTR("There is not becoming empty in the list.") );
			}
		}

	/* R}hꗗu?v				*/
	} else if ( ( strcasecmp_P( cmd ,PSTR("?") ) == 0 ) || ( strcasecmp_P( cmd ,PSTR("help") ) == 0 ) ) {
		sfUsartPuts_P( PSTR("reset<CR>       : Software is reset.") );
		sfUsartPuts_P( PSTR("info<CR>        : System information is returned.") );
		sfUsartPuts_P( PSTR("play<CR>        : The reproduction is restarted.") );
		sfUsartPuts_P( PSTR("pause<CR>       : The reproduction is temporarily stopped.") );
		sfUsartPuts_P( PSTR("monitor<CR>     : The monitor of the buffer begins.") );
		sfUsartPuts_P( PSTR("dump n<CR>      : SD card sector dump.") );
		sfUsartPuts_P( PSTR("list<CR>        : The list of the registered server is output.") );
		sfUsartPuts_P( PSTR("add<CR>         : Server information being connected now is added.") );
		sfUsartPuts_P( PSTR("ch n<CR>        : It changes to the server of a specified index.") );
		sfUsartPuts_P( PSTR("del n<CR>       : The server registered information of a specified index is deleted.") );
		sfUsartPuts_P( PSTR("eraseall<CR>    : All server information is deleted.") );
		sfUsartPuts_P( PSTR("http://....<CR> : The shoutcast server is changed.") );
		sts = 0;

	} else {
		sts = 1;
	}

	if ( cmd[0] ) {
		if ( sts ) {
			sfUsartPuts_P( PSTR("NG") );
		} else {
			sfUsartPuts_P( PSTR("OK") );
		}
	}

}

/*****************************************************************************
*							usartMobt@NA
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void clearUsart( void )
{
	rdLen = 0;
	crRecv = 0;
}

/*****************************************************************************
*						CRC`FbNt̃ZN^[h
* Fuint32_t sec ZN^ԍ
* ߒlFuint8_t      0:OK !0:NG
* [Jϐ buf ɓǂݍ܂
*****************************************************************************/
static uint8_t loadSector( uint32_t sec )
{
	uint16_t crc;

	if ( disk_read( 0 ,buf ,sec ,1 ) != RES_OK ) {
		return ( 1 );
	}
	crc = getCRC16( buf ,510 );
	if ( crc != *(uint16_t *)&buf[510] ) {
		memset( buf ,0x00 ,512 );
		*(uint16_t *)&buf[510] = crc;
	}
	
	return ( 0 );
}

/*****************************************************************************
*						CRC`FbNt̃ZN^Cg
* Fuint32_t sec ZN^ԍ
* ߒlFuint8_t      0:OK !0:NG
* [Jϐ buf ܂
*****************************************************************************/
static uint8_t saveSector( uint32_t sec )
{
	uint16_t crc = getCRC16( buf ,510 );
	*(uint16_t *)&buf[510] = crc;
	if ( disk_write( 0 ,buf ,sec ,1 ) != RES_OK ) {
		return ( 1 );
	}
	return ( 0 );
}

/*****************************************************************************
*								CRC16vZ
* Fvoid *p      f[^̈ւ̃|C^
*		uint16_t len f[^oCg 
* ߒlFuint16_t     CRC16l
*****************************************************************************/
static uint16_t getCRC16( void *p ,uint16_t len )
{
	uint8_t *dp = (uint8_t *)p;
	uint16_t crc = 0xffff;
	while ( len-- ) {
		crc = _crc16_update( crc ,*(dp++) );
	}
	crc ^= 0xffff;

	return ( crc );
}

/*****************************************************************************
*							C֐
*****************************************************************************/
int main( void )
{
	/* n[hEGA				*/
	hardwareInit();

	/* ŌɍĐĂURLĐ		*/
	strcpy_P( stationURL ,PSTR("http://scfire-ntc-aa03.stream.aol.com:80/stream/1051") );
	if ( ( loadSector( 100L ) == 0 ) && buf[0] ) {
		strcpy( stationURL ,(char *)&buf[6] );
	}

	/* C[v						*/
	while ( 1 ) {
		playShoutcast( stationURL ,180 );
		WAIT_MS( 1000 );
		hardwareInit();
	}
}
