/*###########################################################################
#                                                                           #
#                          \tgEGAUSART(M̂)						#
#                                                                           #
#            NX^16MHz쓮ŁA300`19200baudx܂              @#
#                                                                           #
###########################################################################*/
#define __SOFT_USART_C__

#include <stdio.h>
#include <string.h>

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include "util/delay.h"
#include "soft_usart.h"

/* ʐMx`						*/
#define BAUD ( 19200 )

/* TXڑ|[g`					*/
#define TX_PORT PORTB
#define TX_DDR  DDRB
#define TX_BIT  0

/* RXڑ|[g`					*/
#define RX_PORT PORTB
#define RX_PIN  PINB
#define RX_DDR  DDRB
#define RX_BIT  1

/* ^C~OEGCg}N			*/
#define WAIT_BAUD() _delay_ms( (double)1000 / (double)BAUD )

/*****************************************************************************
*							\tgEGAUSART
* Fvoid
* ߒlFvoid
******************************************************************************/
void sfUsartInit( void )
{
	/* TX ʐM|[gݒ(o:HI)		*/
	TX_PORT |= _BV(TX_BIT);
	TX_DDR  |= _BV(TX_BIT);

	/* RX ʐM|[gݒ(:Pullup)	*/
	RX_PORT |= _BV(RX_BIT);
	RX_DDR &= ~_BV(RX_BIT);

	/* _~[EGCg					*/
	WAIT_BAUD();
}

/*****************************************************************************
*								ꕶ
* Fvoid
* ߒlFuint8_t ̓f[^
******************************************************************************/
uint8_t sfUsartGetc( void )
{
	uint8_t data = 0;
	uint8_t i = 8;

	/* X^[grbgo				*/
	while ( RX_PIN & _BV(RX_BIT) );					/* LowɂȂ̂҂	*/
	WAIT_BAUD();

	/* f[^荞					*/
	while ( i-- ) {
		data >>= 1;
		if ( RX_PIN & _BV(RX_BIT) ) {
			data |= 0x80;
		}
		WAIT_BAUD();
	}

	/* Xgbvrbg҂				*/
	while ( !( RX_PIN & _BV(RX_BIT) ) );			/* HiɂȂ̂҂		*/

	return ( data );
}

/*****************************************************************************
*								ꕶo
* Fuint8_t c MR[h
* ߒlFvoid
******************************************************************************/
void sfUsartPutc( uint8_t c )
{
	cli();

	/* X^[grbgo				*/
	TX_PORT &= ~_BV(TX_BIT);					/* TX : Low					*/
	WAIT_BAUD();

	/* ʃrbg珇ɑM			*/
	uint8_t i = 8;
	while ( i-- ) {
		if ( c & 0x01 ) {
			TX_PORT |= _BV(TX_BIT);				/* TX : Hi					*/
		} else {
			TX_PORT &= ~_BV(TX_BIT);			/* TX : Low					*/
		}
		c >>= 1;
		WAIT_BAUD();
	}

	/* Xgbvrbgo				*/
	TX_PORT |= _BV(TX_BIT);						/* TX : Hi					*/
	WAIT_BAUD();

	sei();
}

/*****************************************************************************
*								o
* Fchar *txt 
* ߒlFvoid
******************************************************************************/
void sfUsartPuts( char *txt )
{
	while ( *txt ) {
		if ( ( *txt >= 0x20 ) && ( *txt <= 0x7e ) ) {
			sfUsartPutc( *txt );
		}
		txt++;
	}
	sfUsartPutc( '\r' );
	sfUsartPutc( '\n' );
}

/*****************************************************************************
*							o(R[ḧj
* Fchar *txt 
* ߒlFvoid
******************************************************************************/
void sfUsartPuts_P( prog_char *txt )
{
	uint8_t c;
	while ( pgm_read_byte( txt ) ) {
		c = pgm_read_byte( txt++ );
		if ( ( c >= 0x20 ) && ( c <= 0x7e ) ) {
			sfUsartPutc( c );
		}
	}
	sfUsartPutc( '\r' );
	sfUsartPutc( '\n' );
}

/*****************************************************************************
*							f[^_v
* Fvoid *data
*       uint16_t len
* ߒlFvoid
******************************************************************************/
void sfUsartDump( void *data ,uint16_t len )
{
	uint16_t addr = 0;
	uint8_t *p = (uint8_t *)data;
	char buf[80] ,d[8];

	if ( len ) {
		for ( addr = 0 ;addr < len ;addr++ ) {
			if ( ( addr % 16 ) == 0 ) {
				if ( addr ) {
					sfUsartPuts( buf );
				}
				strcpy_P( buf ,PSTR("     :                                                 :                 \n") );
				sprintf_P( d ,PSTR("%04x") ,addr );
				memcpy( buf ,d ,4 );
			}
			sprintf_P( d ,PSTR("%02x") ,*p );
			memcpy( &buf[ 7 + ( 3 * ( addr % 16 ) ) ] ,d ,2 );
			if ( ( *p >= 0x20 ) && ( *p <= 0x7e ) ) {
				buf[ 57 + ( addr % 16 ) ] = *p;
			} else {
				buf[ 57 + ( addr % 16 ) ] = '.';
			}
			p++;
		}
		sfUsartPuts( buf );
	}
	sfUsartPuts_P( PSTR("\n") );
}
